%define module megaraid
%define version v2.20.4.4
%define platform RHEL4-GA
%define base_kernel 2.6.9-5
%define architecture x86_64

Summary:	megaraid dkms package
Name:		%{module}
Version:	%{version}
Release:	2dkms
Vendor:		LSI
License:	GPL
Packager:	Rajesh Prabhakaran <rajesh.prabhakaran@lsil.com>  
Group:		System Environment/Base
BuildArch:	x86_64
Requires:	dkms >= 1.00
Requires:	bash
Source0:	%{module}-%{version}-for-%{platform}-kernel%{base_kernel}-%{architecture}-all.tgz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root/

%description
This package contains LSI's megaraid module wrapped for the DKMS framework.

%prep
rm -rf %{module}-%{version}
mkdir %{module}-%{version}
cd %{module}-%{version}
tar xvzf $RPM_SOURCE_DIR/%{module}-%{version}-*-kernel%{base_kernel}-*-all.tgz

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/
mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/patches
mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}/redhat_driver_disk

cp -rf %{module}-%{version}/* $RPM_BUILD_ROOT/usr/src/%{module}-%{version}

install -m 644 $RPM_SOURCE_DIR/%{module}-%{version}-*-kernel%{base_kernel}-*-all.tgz $RPM_BUILD_ROOT/usr/src/%{module}-%{version}

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(0644,root,root)
/usr/src/%{module}-%{version}/

%pre

%post
dkms add -m %{module} -v %{version} --rpm_safe_upgrade

# Load tarballs as necessary
loaded_tarballs=""

for kernel_name in 2.6.9-5.EL; do
        if [ -d "/lib/modules/$kernel_name" ] && [ `uname -m | grep -c "x86_64"` -gt 0 ]; then
                echo -e ""
                echo -e "Loading/Installing pre-built modules for $kernel_name."
                dkms ldtarball --archive=/usr/src/%{module}-%{version}/%{module}-%{version}-for-%{platform}-kernel%{base_kernel}-%{architecture}-bin.tgz >/dev/null
                dkms install -m %{module} -v %{version} -k ${kernel_name} >/dev/null 2>&1
                dkms install -m %{module} -v %{version} -k ${kernel_name}smp >/dev/null 2>&1
		[ `uname -r | grep -c "$kernel_name"` -gt 0 ] && loaded_tarballs="true"
        fi
done

# If we haven't loaded a tarball, then try building it for the current kernel
if [ -z "$loaded_tarballs" ]; then
	if [ `uname -r | grep -c "BOOT"` -eq 0 ] && [ -e /lib/modules/`uname -r`/build/include ]; then
		echo -e "dkms build start"
		dkms build -m %{module} -v %{version}
		echo -e "dkms build done"
		echo -e "dkms install start"
		dkms install -m %{module} -v %{version}
		echo -e "dkms install done"
	elif [ `uname -r | grep -c "BOOT"` -gt 0 ]; then
		echo -e ""
		echo -e "Module build for the currently running kernel was skipped since you"
		echo -e "are running a BOOT variant of the kernel."
	else 
		echo -e ""
		echo -e "Module build for the currently running kernel was skipped since the"
		echo -e "kernel source for this kernel does not seem to be installed."
	fi
fi
exit 0

%preun
echo -e
echo -e "Uninstall of megaraid module (version %{version}) beginning:"
dkms remove -m %{module} -v %{version} --all --rpm_safe_upgrade
exit 0

%changelog
* Wed Dec 16 2004 Sreenivas Bagalkote <Sreenivas.Bagalkote@lsil.com>
- Released for megaraid v2.20.4.2/2.20.2.4 for built-in 2.6.9.1-648_EL/smp/hugemem
* Thu Jan 27 2004 Seokmann Ju <Seokmann.Ju@lsil.com>
- Released for megaraid v2.20.4.4/2.20.2.5 for built-in 2.6.9.1-906_EL/smp
